--[[
	Description: Titan plug-in to display professions skill level
	Author: Subwired
--]]

local ProfName = "Fishing"
local menutext = "Titan|cC79C6E00 "..ProfName.."|r"
local buttonlabel = ProfName..": "
local ID = "FH"
local elap, FH, prevFH = 0, 0.0, -2
local FHmax = 0



-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelFHButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")


function f:ADDON_LOADED(a1)

--print ("a1 = " .. a1)
	if a1 ~= "TitanFishing" then 
		return 
	end
	
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	
	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelFHButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelFHButton_GetTooltipText",
		frequency = 1,
		icon = "Interface\\Icons\\Trade_"..strlower(ProfName)..".blp",
		iconWidth = 16,
		category = "Profession",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			
		},
	}
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end

		--local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
		--local name, icon, skillLevel, maxSkillLevel, numAbilities, spelloffset, skillLine, skillModifier = GetProfessionInfo(index)
			
		local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
		
		if fishing ~= nil then
			local name, _, skillLevel, maxSkillLevel, _, _, _, _ = GetProfessionInfo(fishing)
			FH = skillLevel
			FHmax = maxSkillLevel
			
			if FH == prevFH and prevFHmax == FHmax then 
				return 
			end
			
			prevFHmax = FHmax
			prevFH  = FH
			TitanPanelButton_UpdateButton(ID)
			elap = 0
		end
	end)
		
	--TitanPanelButton_OnLoad(self)
end

----------------------------------------------
function TitanPanelFHButton_GetButtonText()
----------------------------------------------
	local FHtext, pitchtext
	if not FH then
		FHtext = "??"
	else
	
		FHtext = FH .."/"..FHmax--string.format("%.0f", FH)  
	end
	return buttonlabel, FHtext
end

-----------------------------------------------
function TitanPanelFHButton_GetTooltipText()
-----------------------------------------------
	return "Displays your current "..ProfName.." Skill level"
end

local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end
----------------------------------------------------
function TitanPanelRightClickMenu_PrepareFHMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end